//---------------------------------------------------------------------------
// MixDir() is in global.cpp
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixmastDlg.h"
#include "Global.h"
#include "WipeDlgs.h"
#include "Mixmaster.h"
#include "wipedlgs.h"
#include "Pgp.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMixForm *MixForm;
//---------------------------------------------------------------------------
int __fastcall data_encrypt(char **data, long &datlen, char *password, int paslen)
{
   int result;
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_append(pas,(byte*)password,paslen);
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_encrypt(PGP_CONVENTIONAL|PGP_NOARMOR,dat,pas,NULL,NULL,NULL,NULL))==0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy uncompressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(pas); buf_free(dat);
   return result;
}
//---------------------------------------------------------------------------
int __fastcall data_decrypt(char **data, long &datlen, char *password, int paslen)
{
   int result;
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_append(pas,(byte*)password,paslen);
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_decrypt(dat,pas,NULL,NULL,NULL))==0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy uncompressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(pas); buf_free(dat);
   return result;
}
/*
//---------------------------------------------------------------------------
int __fastcall data_compress(char **data, long &datlen)
{
   int result;
   BUFFER *dat = buf_new(); dat->sensitive = true;
   // put data in buffer
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_encrypt(PGP_NOARMOR,dat,NULL,NULL,NULL,NULL,NULL)) == 0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy compressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(dat);
   return result;
}
//---------------------------------------------------------------------------
int __fastcall data_uncompress(char **data, long &datlen)
{
   int result;
   BUFFER *dat = buf_new(); dat->sensitive = true;
   // put compressed data in buffer
   buf_append(dat,(byte*)*data,datlen);
   if ((result = pgp_decrypt(dat,NULL,NULL,NULL,NULL)) == 0)
   {
      delete *data; *data = new char[dat->length+1];
      // copy uncompressed data to data variable
      memcpy(*data,dat->data,dat->length+1);
      // set new length
      datlen = dat->length;
   }
   buf_free(dat);
   return result;
}
*/
//---------------------------------------------------------------------------
// Encrypt & Decrypt QuickSilver Database
//---------------------------------------------------------------------------
int __fastcall PgpEncryptQSDBC(TDataBuf *Passphrase)
{
   char *sessionkey = GetSessionKey();//(char*)ActMainForm->Perform(WM_GETSESSIONKEY,0,0);
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...encrypting "+ExtractFileName(AppDat).LowerCase()+"...";
   MixForm->Mode = modePgpEncryptQSDBC;
   MixForm->Caption = "Pgp";
   AppProcessMessages();
   Passphrase->Decrypt(sessionkey);
   MixForm->Passphrase = (char*)Passphrase->data; MixForm->ShowModal();
   Passphrase->Encrypt(sessionkey);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   AppProcessMessages();
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpDecryptQSDBC(TDataBuf *Passphrase)
{
   //char *sessionkey = (char*)ActMainForm->Perform(WM_GETSESSIONKEY,0,0);
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...decrypting "+ExtractFileName(AppDat.LowerCase())+"...";
   MixForm->Mode = modePgpDecryptQSDBC;
   MixForm->Caption = "Pgp";
   AppProcessMessages();
   //Passphrase->Decrypt(sessionkey);
   MixForm->Passphrase = Passphrase->c_str(); MixForm->ShowModal();
   //Passphrase->Encrypt(sessionkey);
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   AppProcessMessages();
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
int __fastcall PgpEncryptConventional(TStrings *Message, AnsiString &Passphrase)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Mode = modePgpEncryptConventional;
   MixForm->Cap = "...encrypting message...";
   MixForm->Message->Text = Message->Text;
   MixForm->Caption = "Pgp";
   MixForm->Passphrase = Passphrase; MixForm->ShowModal();
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Message->Text = MixForm->Message->Text;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpDecryptConventional(TStrings *Message, AnsiString &Passphrase,
   int &errcode)
{
   MixForm = new TMixForm(Application->MainForm);
   MixForm->Cap = "...decrypting message...";
   MixForm->Message->Text = Message->Text;
   MixForm->Mode = modePgpDecryptConventional;
   MixForm->Caption = "Pgp";
   MixForm->Passphrase = Passphrase; MixForm->ShowModal();
   int ret = MixForm->ModalResult;
   if (MixForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Message->Text = MixForm->Message->Text;
   errcode = MixForm->Result;
   delete MixForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpEncryptConventional()
{
   AnsiString line;
   BUFFER *dat = buf_new(), *enc = buf_new();
   dat->sensitive = true; enc->sensitive = true;
   Application->ProcessMessages();
   buf_sets(enc,Passphrase.c_str());
   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_TEXT,dat,enc,NULL,NULL,PKeyRing.c_str(),NULL);
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: Message->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(enc); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpDecryptConventional()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_appends(pas,Passphrase.c_str()); ClearString(Passphrase);
   buf_appends(dat,Message->Text.c_str());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) Message->SetText((char*)dat->data);
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
// Encrypt/Decrypt QS database
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpEncryptQSDBC()
{
   BUFFER *dat = buf_new(), *pas = buf_new(), *enc = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_appends(pas,Passphrase.c_str());
   buf_readfile(dat,AppDat.c_str());
   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_NOARMOR,dat,pas,NULL,enc,NULL,NULL);
   if (Result==PGP_OK)
   {
      CopyFile(AppPgp.c_str(),AppPgpBak.c_str(),false);
      buf_writefile(dat,AppPgp.c_str(),"wb");
   }
   buf_free(enc); buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMixForm::PgpDecryptQSDBC()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   buf_appends(pas,Passphrase.c_str());
   buf_readfile(dat,AppPgp.c_str());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (Result==PGP_OK)
      buf_writefile(dat,AppDat.c_str(),"wb");
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
// Mixform progress dialog
//---------------------------------------------------------------------------
__fastcall TMixForm::TMixForm(TComponent* Owner)
  : TForm(Owner)
{
   Position = poScreenCenter;
   if (Application->MainForm)
   {
      Position = poDesigned;
      TForm *Main = Application->MainForm;
      Top = Main->Top+((Main->Height-Height)/2);
      Left = Main->Left+((Main->Width-Width)/2);
   }
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
   Message = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::FormDestroy(TObject *Sender)
{
   ClearString(Passphrase);
   delete Message;
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   //Sleep(500);
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Label1->Caption = Cap;
   AppProcessMessages();
   switch (Mode)
   {
      case modePgpEncryptQSDBC: PgpEncryptQSDBC(); break;
      case modePgpDecryptQSDBC: PgpDecryptQSDBC(); break;
      case modePgpEncryptConventional: PgpEncryptConventional(); break;
      case modePgpDecryptConventional: PgpDecryptConventional(); break;
   }
   AppProcessMessages();
   if (ModalResult == mrNone)
       ModalResult = mrOk;
 }
//---------------------------------------------------------------------------
void __fastcall TMixForm::Timer2Timer(TObject *Sender)
{
   if (Label1->Caption.IsEmpty()) Label1->Caption = Cap;
   else Label1->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TMixForm::Timer3Timer(TObject *Sender)
{
   ProgressBar->Position += (WORD)1;
   if (*Cancelled && ProgressBar->Position<100)
   {
      int start = ProgressBar->Position;
      for (int i=start; i<=100; i++)
      {
         ProgressBar->Position += (WORD)1;
         Application->ProcessMessages();
         Sleep(1);
      }
      Timer3->Enabled = false;
      ModalResult = mrCancel;
   }
}
//---------------------------------------------------------------------------




